#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'cartit.cgi'} = "8.0.07.377";
#All systems
if($^O eq 'MSWin32'){
	my $scriptname = $0;
	$scriptname =~ s/^(.*)[\/\\]([^\/\\]+)$/$2/;
	push(@INC,$1);
}

require ('cartitcf.cgi');
require ('cartitlib.cgi');
require ('cartitimg.util');
######################################################################
# $NOCACHE Will cause CartIt to auto expire page display, back button
# will reload CartIt Can cause problems in some browser as it will
# say "Page has Expired" instead of auto reload.
######################################################################



$NOCACHE = 0;

$|=1;
if(-e "$data_directory/manager.lock"){
	&print_http_header;
	&system_busy('System is locked, unlock it with CommerceBuddy, Online -&gt; Maintenance &gt; Unlock CartIt');
}

# DO NOT REMOVE!
&about_cartit if($ENV{'QUERY_STRING'} eq "about");
&get_configs;
&shopper_ban_message if(&shopper_banned);
&parse_form;
&get_cart_id;
&do_activate_session;
&go_cartit if($ENV{'QUERY_STRING'} eq '' && $ENV{'REQUEST_METHOD'} eq 'GET');
$SAFE_REQUEST= &refsec_access;
&jamsession;


sub jamsession{
	
	
	if($WEBDAT{'lhm'} ne ''){
		$ITEMS{"$WEBDAT{'lhm'}"} = 0;
		$WEBDAT{'HITMAN'} =1;
		
	}
	
	
	if($WEBDAT{'sfl'} ne ''){
		$SAVEIT{"$WEBDAT{'sfl'}"} = 1;
		$ITEMS{"$WEBDAT{'sfl'}"} = $WEBDAT{'sq'};
		$WEBDAT{'HITMAN'} =1;
	}
	
	
	
	
	&show_currency_options if($WEBDAT{'command'} eq 'currency_options');
	&set_currency if($WEBDAT{'command'} eq 'set_currency' && $WEBDAT{'currency_value'} ne '');
	&hitman if($WEBDAT{'HITMAN'} == 1 && defined(%ITEMS));
	
	&empty if($WEBDAT{'command'} eq 'empty');
	
	if(($SAFE_REQUEST) && ($USERCUSTOM{'enable_cookie_cfo'})){
		if($WEBDAT{'cartit_set_cookie'} ne ""){
			local($myname,$myvalue,$myexp,$mytype,$action,$actionvalue) = split(/\^/,$WEBDAT{'cartit_set_cookie'});
			&set_cookie($myname,$myvalue,$myexp,$mytype);
			if(($action eq "redirect") && ($actionvalue =~ /^http:\/\/.+/)){
				print "Location: $actionvalue\n\n";
				exit(0);
				}elsif($action eq "printfile"){
				if(&put_file($actionvalue)){
					exit(0);
					}else{
					&print_http_header;
					&errorform("Document does not exist: $actionvalue");
				}
			}
			
		}#COOKIE
	}
	
	&add_items;
}

# ------------------------------------------------------------------------------------
sub refsec_access{
	
	if($ENV{'HTTP_REFERER'} eq ""){
		return(0) if($USERCONFIGS{'sec_reject_nullref'} && $ENV{'HTTP_REFERER'} eq "");
		}else{
		return(0) if($ENV{'HTTP_REFERER'} !~ m!$USERCONFIGS{'sec_urlexp'}!)
	}
	return(0) if($ENV{'REQUEST_METHOD'} eq 'POST' && $USERCONFIGS{'sec_reject_post'});
	return(0) if($ENV{'REQUEST_METHOD'} ne 'POST' && $USERCONFIGS{'sec_reject_get'});
	return(1);
}

# ------------------------------------------------------------------------------------
sub add_items{
	
	if((!$SAFE_REQUEST)&&(($WEBDAT{'cartitadd'} ne '') || (@addit) || (@cartitqa) || ($WEBDAT{'description'} ne ''))){
		&errorform('<b>The item added to the shopping cart violated the security on this web site and was not added to prevent fraud. <p>If you are the operator of this web site, please see product support documents and technical articles in the support section of the CartIt web site for further information. <p>Articles to See: 220</b>')
	}
	if($SAFE_REQUEST){
		my $items =&get_newitems;
		if($items ne ''){
			$global_items_added = 1;
			open(CART, ">>$cart_directory/$cart_ID.cart")|| &system_error('Could Not Open Cart!','Exited');
			print CART "$items";
			close(CART);
		}
	}
	
	&go_cartit;
	
}

# ------------------------------------------------------------------------------------
sub empty{
	if(-e "$cart_directory/$cart_ID.cart"){
		open(CART, ">$cart_directory/$cart_ID.cart")|| &system_error('Could Not Open Cart!','Exited');
		close(CART);
	}
	&go_cartit;
}

# ------------------------------------------------------------------------------------
sub hitman{
	my $cartfile = $WEBDAT{'savcart'} != 1 ? 'cart' : 'saved';
	my $ocartfile = $WEBDAT{'savcart'} !=1 ? 'saved' : 'cart';
	
	my($recs);
	my $cartline_string = '';
	my $cartline_string_moved = '';
	$/='{ENDCARTITITEM}';
	
	open(CART, "$cart_directory/$cart_ID.$cartfile")||&system_error('Could Not Open Cart!','Exited');
	
	
	my(@RECS) = (<CART>);
	close(CART);
	chomp(@RECS);
	
	$/=\n;
	
	foreach $recs (@RECS){
		my($q,$sk,$d,$ed,$p,$w,$id,$taxable,$smarttaxname,$smarttaxperc,$smartistaxable,$smartcondition,$mref,$giftname,$giftfee,$cartitqd) = split(/\|/,$recs);
		$ITEMS{"$id"}=$q if($ITEMS{"$id"} eq '');
		$ITEMS{"$id"}=1 if($ITEMS{"$id"} >=10000 || $ITEMS{"$id"}=~/\D/ || $ITEMS{"$id"} eq "");
		if($ITEMS{"$id"}>0 && !$SAVEIT{"$id"}){
			$cartline_string .= "$ITEMS{$id}\|$sk\|$d\|$ed\|$p\|$w\|$id\|$taxable\|$smarttaxname\|$smarttaxperc\|$smartistaxable\|$smartcondition\|$mref\|$giftname\|$giftfee\|$cartitqd";
			$cartline_string .= '{ENDCARTITITEM}';
			}elsif($SAVEIT{"$id"}==1){
			$WARN_GIFT_MOVE =1 if($giftname ne '');
			$cartline_string_moved .= "$ITEMS{$id}\|$sk\|$d\|$ed\|$p\|$w\|$id\|$taxable\|$smarttaxname\|$smarttaxperc\|$smartistaxable\|$smartcondition\|$mref\|\|\|$cartitqd";
			$cartline_string_moved .= '{ENDCARTITITEM}';
		}
		
		
	}
	
	open(CART, ">$cart_directory/$cart_ID.$cartfile")||&system_error('Could Not Open Cart!','Exited');
	print CART "$cartline_string";
	close(CART);
	
	if($cartline_string_moved ne ''){
		open(CART, ">>$cart_directory/$cart_ID.$ocartfile")||&system_error('Could Not Open Cart!','Exited');
		print CART "$cartline_string_moved";
		close(CART);
	}
	
	
	
	&do_go_cartit;
	
}




# ------------------------------------------------------------------------------------
sub go_cartit{
	my $thisfile;
	my $bref;
	$bref = $WEBDAT{'bounceto'}=~ m!http://.+! ? $WEBDAT{'bounceto'} : $ENV{'HTTP_REFERER'};
	
	&set_cookie('cid',"$cart_ID",25,'hours');
	&set_cookie('shopping_id',"$cart_ID",0,'session');
	
	
	
	
	$WEBDAT{'bounce'}=1 if($WEBDAT{'dynamic_cartit'} eq 'bounce');
	$thisfile = $WEBDAT{'dynamic_cartit'} ne '' ? $WEBDAT{'dynamic_cartit'} : $USERCUSTOM{'CARTIT_DISPLAY'};
	$thisfile = &remove_specials($thisfile);
	if($WEBDAT{'bounce'} ne '1' && $USERCUSTOM{'CARTIT_BOUNCE'}==0 && ($global_items_added==1||$thisfile=~/frame/)){
		if(($thisfile ne '') && (-e "$data_directory/$thisfile")){
			&get_cart_total;
			&print_http_header;
			$USERCONFIGS{'items_in_cart'}= sprintf("%2d",$CUSTOM_SHIPPING_ITEMS_IN_CART);
			$USERCONFIGS{'cartit_location'} = "$USERCONFIGS{'cgi_bin'}/cartit.cgi";
			$USERCONFIGS{'cart_total'} =sprintf("$USERCONFIGS{'money_sign'}%.2f",$USERCONFIGS{'cart_total'});
			print &get_file_as_iostring($thisfile);
			}else{
			&do_go_cartit;
		}
		
		
		
		}elsif(($WEBDAT{'bounce'} eq '1' || $USERCUSTOM{'CARTIT_BOUNCE'}==1) &&($bref ne "") && ($WEBDAT{'bounce'} ne '0')&&($global_items_added==1)){
		
		print "Location: $bref\n\n";
		exit(0);
		}else{
		
		&do_go_cartit;
		
	}
	
	
	sub do_go_cartit{
		&print_http_header;
		&print_document_top('Your Personal Shopping Cart');
		print &show_cartit(1);
		&print_document_foot;
		print "$thisfile";
		exit(0);
		
		
	}
	
	
}


# ------------------------------------------------------------------------------------
sub get_newitems{
	
	my ($sops,$eops,$i,$add_fees,$addits,$unid,$cookiename,$cookievalue,$faildoc,$taxtype,$taxperc,$taxable);
	
	if($WEBDAT{'cartit_item_requires_cookie'} ne ""){
		($cookiename,$cookievalue,$faildoc) = split(/\^/,$WEBDAT{'cartit_item_requires_cookie'});
		if(&get_cookie("$cookiename") ne "$cookievalue"){
			if(&put_file($faildoc)){
				exit(0);
				}else{
				&print_http_header;
				&errorform("This product requires a special shopper identification. Please contact $USERCONFIGS{'company_name'} for additional information.");
			}
		}
		
	}
	
	
	if(-e "$data_directory/smarttaxes.txt"){
		if(-s "$data_directory/smarttaxes.txt"){
			my(@SITEMS,$stline);
			open (FILE, "$data_directory/smarttaxes.txt") || &system_error('Could Not Open Cart!','Exited');
			@SITEMS = (<FILE>);
			close(FILE);
			chomp(@SITEMS);
			foreach $stline (@SITEMS){
				my($code,$showname,$perc,$istaxagain,$condition) = split(/\|/,$stline);
				$SMARTTAXES{$code} = "$showname\|$perc\|$istaxagain\|$condition";
			}
			
		}
	}
	
	
	
	
	my($cartline_string) = '';
	return('')if(($WEBDAT{'cartitadd'} eq '') && (!@addit) && (!@cartitqa) && ($WEBDAT{'description'} eq ''));
	($WEBDAT{'description'}, $WEBDAT{'price'}, $WEBDAT{'shipit'}, $WEBDAT{'taxable'},$smarttax_id) = split(/\^/,$WEBDAT{'cartitadd'})if($WEBDAT{'cartitadd'});
	$WEBDAT{'price'} =~ s/[^0-9\.]//g;
	$WEBDAT{'taxable'} = $USERCONFIGS{'taxable'} if($WEBDAT{'taxable'} eq "");
	return(0)if(($WEBDAT{'description'} eq "") && (!@addit) && (!@cartitqa));
	$WEBDAT{'quantity'}="1" if ($WEBDAT{'quantity'} >=10000 ||$WEBDAT{'quantity'}=~/\D/ || $WEBDAT{'quantity'}eq "");
	$unid = &gen_unique_id;
	if(($ENV{'HTTP_REFERER'} ne "")&&($ENV{'HTTP_REFERER'}!~ /$NOTRACK_REFS/)){
		$REF_LINK = $ENV{'HTTP_REFERER'};
	}

	$WEBDAT{'shipit'} = &convert_to_oz($WEBDAT{'shipit'});
	
	$WEBDAT{'description'}= '' if(length($WEBDAT{'description'})>250);
	
	if($WEBDAT{'description'} =~ /:##:/){
		($WEBDAT{'sku'},$WEBDAT{'description'}) = split(/:##:/,$WEBDAT{'description'});
	}
	
	
	if(($WEBDAT{'description'} ne '') && ($WEBDAT{'price'} > 0) && ($WEBDAT{'quantity'} > 0)){
		$cartline_string = "$WEBDAT{'quantity'}\|$WEBDAT{'sku'}\|$WEBDAT{'description'}\|";
		
		
		if(@eop || @sop){
			$cartline_string .= $USERCUSTOM{'START_OPTIONS'} . $USERCUSTOM{'OPTIONS_DISPLAY_TEXT'} ;
			
			
			if(@sop){
				$OP_SIZE = @sop;
				$i=0;
				foreach $sops (@sop){
					$i++;
					$cartline_string  .= "$sops";
					$cartline_string  .= ", "if($i<$OP_SIZE);
				}
				
			}
			
			
			if (@eop){
				$OP_SIZE = @eop;
				$i=0;
				$cartline_string  .= ', ' if(@sop);
				foreach $eops (@eop){
					my($described, $option, $eoprice, $eoshipit) = split (/\^/,$eops);
					$i++;
					$WEBDAT{'price'} += $eoprice;
					
					$WEBDAT{'shipit'} += &convert_to_oz($eoshipit);
					
					
					
					
					
					$cartline_string  .= "$option $described";
					if($eoprice > 0){
						$eoprice = (sprintf("%.2f",$eoprice));
						$cartline_string  .= sprintf(" for $USERCONFIGS{'money_sign'}%.2f",$eoprice)if(!$USERCUSTOM{'HIDE_OPTION_FEES'});
						$add_fees = 1;
					}
					$cartline_string  .=  ", " if($i<$OP_SIZE);
				}
			}
			
			$cartline_string  .=  $USERCUSTOM{'END_OPTIONS'};
			
		}
		
		
		
		if (@textadd){
			$i=0;
			$cartline_string  .=  $USERCUSTOM{'START_OPTIONS'} . $USERCUSTOM{'TEXT_OPTIONS_DISPLAY_TEXT'};
			foreach $texts (@textadd){
				my($textfor, $thetext, $textprice) = split (/\^/,$texts);
				$i++;
				$WEBDAT{'price'} += $textprice;
				$cartline_string  .= " $textfor\=$thetext";
				if($textprice){
					$cartline_string  .= sprintf(" for $USERCONFIGS{'money_sign'}%.2f",$textprice)if(!$USERCUSTOM{'HIDE_OPTION_FEES'});
					$add_fees =1;
				}
				
				$cartline_string  .=  ', 'if($i<@textadd);
			}
			$cartline_string  .= $USERCUSTOM{'END_OPTIONS'};
			$i=0;
		}
		
		
		$cartline_string  .= $USERCUSTOM{'ALL_FEES_REFLECTED'} if($add_fees);
		$cartline_string  .= '|'; #Close Options
		
		
		$smarttax_id = uc($smarttax_id);
		my($smarttaxline_here) = $SMARTTAXES{$smarttax_id};
		$smarttaxline_here = '|||'if($smarttaxline_here eq "");
		
		
		
		$WEBDAT{'shipit'} = &convert_to_oz($USERCONFIGS{'weight_safety'}) if ($USERCONFIGS{'shipping_method'} eq 'livemethods' && $WEBDAT{'shipit'} <= 0);
		
		$cartline_string  .=  sprintf("%.2f\|$WEBDAT{'shipit'}\|%s\|$WEBDAT{'taxable'}\|$smarttaxline_here\|$REF_LINK\|\|\|$WEBDAT{'cartitqd'}\{ENDCARTITITEM\}",$WEBDAT{'price'},$unid,$taxperc);
		$LINEITEMS{$unid} = $WEBDAT{'quantity'};
	}
	
	if(@addit){
		foreach $addits (@addit){
			my($description, $price, $shipit, $taxable,$smarttax_id) = split (/\^/,$addits);
			if($description =~ /:##:/){
				($sku,$description) = split(/:##:/,$description);
			}
			next if(length($description)>250);
			next if(length($sku)>50);
			
			$shipit = &convert_to_oz($shipit);
			$smarttax_id = uc($smarttax_id);
			my($smarttaxline_here) = $SMARTTAXES{$smarttax_id};
			$smarttaxline_here = '|||'if($smarttaxline_here eq "");
			
			
			if($description ne '' && $price > 0){
				$taxable = $USERCONFIGS{'taxable'} if($taxable eq "");
				$unid++;
				$shipit = &convert_to_oz($USERCONFIGS{'weight_safety'}) if ($USERCONFIGS{'shipping_method'} eq 'livemethods' && $shipit <= 0);
				$cartline_string  .= sprintf("1\|$sku\|$description\|\|%.2f\|$shipit\|$unid\|$taxable\|$smarttaxline_here\|$REF_LINK\|\|\|$WEBDAT{'cartitqdc'}\{ENDCARTITITEM\}",$price);
				$LINEITEMS{$unid} = 1;
				
			}
		}
	}
	
	
	if(@cartitqa){
		foreach $qa (@cartitqa){
			my($description, $price, $shipit,$taxable,$smarttax_id,$quantity) = split (/\^/,$qa);
			
			
			if($description =~ /:##:/){
				($sku,$description) = split(/:##:/,$description);
			}
			next if(length($description)>250);
			next if(length($sku)>50);
			$shipit = &convert_to_oz($shipit);
			$smarttax_id = uc($smarttax_id);
			my($smarttaxline_here) = $SMARTTAXES{$smarttax_id};
			$smarttaxline_here = '|||'if($smarttaxline_here eq "");
			
			if(($description ne '') && ($price > 0) && ($quantity > 0)){
				$taxable = $USERCONFIGS{'taxable'} if($taxable eq "");
				$unid++;
				$shipit = &convert_to_oz($USERCONFIGS{'weight_safety'}) if ($USERCONFIGS{'shipping_method'} eq 'livemethods' && $shipit <= 0);
				$cartline_string  .= sprintf("$quantity\|$sku\|$description\|\|%.2f\|$shipit\|$unid\|$taxable\|$smarttaxline_here\|$REF_LINK\|\|\|$WEBDAT{'cartitqdc'}\{ENDCARTITITEM\}",$price);
				$LINEITEMS{$unid} = $quantity;
				
			}
		}
	}
	
	
	
	
	return($cartline_string);
}


sub show_currency_options{
	&print_document_top('Currency Conversion');
	print &get_file_as_iostring('currency_options_header.html');
	print &get_currency_list;
	&print_document_foot;
	print &get_file_as_iostring('currency_options_footer.html');
	exit;
}





