#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'cartitcclib.cgi'} = "8.0.07.377";



######################################################################
# $ssl_debug = 0|1|2|3
# 0 = Live, NO Debug.
# 1 = Debug connection_hash data that will be sent to service.
# 2 = debug results from the connection service as raw data.
# 3 = debug array results from the connection.
######################################################################
$ssl_debug =0;

######################################################################
# if $ssl_debug_auth has an IP address only a computer with
# That IP address can debug CartIt.
# Otherwise - will receive a  /security testing/ error message.
######################################################################
$ssl_debug_auth = '192.168.0.1';




sub check_card{
	my $to_result = 0;
	
	&errorform('CartIt Credit Card processing system is in debug mode, your IP address does not have permission to this debug information.') if($ssl_debug &&  $ENV{'REMOTE_ADDR'} ne $ssl_debug_auth &&  $ssl_debug_auth ne '');
	
	
	
# Return if NO method is defined.
	return(1)if((!$USERCUSTOM{'VALIDATE_CC_METHOD'}) && (!$USERCONFIGS{'cc_rtime'}));
	
	my($cnum, $ctype) = ($WEBDAT{'ccnum'},$WEBDAT{'ccname'});
	my($clength, $pos, $digit,$testnum);
	$cnum =~ s/\D//g;
	if($cnum eq ""){
		$ERROR{'CC_NUMBER'} = &get_error_string('No Credit Card number was entered.');
		$to_result++;
	}
	
	
	$clength = length($cnum);
		my %months = (
		'Jan'	=>	'01',
		'Feb'	=>	'02',
		'Mar'	=>	'03',
		'Apr'	=>	'04',
		'May'	=>	'05',
		'Jun'	=>	'06',
		'Jul'	=>	'07',
		'Aug'	=>	'08',
		'Sep'	=>	'09',
		'Oct'	=>	'10',
		'Nov'	=>	'11',
		'Dec'	=>	'12'
	);
	
	
	
	
	my($day, $month, $mday, $time, $year) = split(/\s+/,localtime(time()));
	my($testyear) = $year.$months{$month};
		if($WEBDAT{'ccyr'} < 99){#Y2K
		$testyear2 = '20'.$WEBDAT{'ccyr'};
		}else{
		$testyear2 = '19' . $WEBDAT{'ccyr'};
	}
	$testyear2 =$testyear2 . $WEBDAT{'ccmo'};
	
	if($testyear>$testyear2){
		$ERROR{'CC_DATE'} = &get_error_string('Credit card expiration date is not valid.');
		$to_result++;
	}
	if($USERCONFIGS{'ask_cvv'} && $USERCONFIGS{'shipping_method'} eq 'livemethods'){
		if($WEBDAT{'cvv2'} !~/\d\d\d\d?/){
			$ERROR{'CC_CVV'} = &get_error_string('You did not enter your Credit Card Verification Code.');
			$to_result++;
		}
	}
	
	return($to_result)if($USERCUSTOM{'VALIDATE_CC_METHOD'}==1);
	my $c__test;
	if($ctype eq 'Visa'){
		$c__test = 'Visa' unless(($clength == 16 || $clength == 13) && substr($cnum,0,1) == 4);
		}elsif($ctype eq 'MasterCard'){
		$c__test = 'MasterCard' unless($clength == 16 && substr($cnum,0,2) >= 51  && substr($cnum,0,2) <= 55);
		}elsif ($ctype eq 'American Express'){
		$c__test = 'American Express' unless(($clength == 15)  && (substr($cnum,0,2) == 34  || substr($cnum,0,2) == 37));
		}elsif ($ctype eq 'Discover'){
		$c__test = 'Discover' unless($clength == 16  && substr($cnum,0,4) eq '6011');
		}elsif ($ctype eq 'Diners Club'){
		$c__test = 'Diners Club' unless(($clength == 14)  && (substr($cnum,0,2) == 30  || substr($cnum,0,2) == 36 || substr($cnum,0,2) == 38));
		}elsif ($ctype eq 'enRoute'){
		$c__test = 'Diners Club' unless(($clength == 15)  && (substr($cnum,0,4) == 2014  || substr($cnum,0,4) == 2149));
		}elsif ($ctype eq 'JCB'){
		$c__test = 'JCB' unless(($clength == 16)  && (substr($cnum,0,4) == 3088  || substr($cnum,0,4) == 3096 || substr($cnum,0,4) == 3112 || substr($cnum,0,4) == 3158 || substr($cnum,0,4) == 3337 || substr($cnum,0,4) == 3528));
		
		
		
	}
	if($c__test ne ''){
		$to_result++;
		$ERROR{'CC_TYPE'} = &get_error_string("You selected &quot;$c__test&quot; Card but the number you entered below is not a valid &quot;$c__test&quot; Card number. You may have selected the incorrect card type or you may have entered the card number incorrectly.");
	}
	
	@cdigit = split('', reverse($cnum));
	for($pos = 1; $pos < $clength; $pos +=2){
		$cdigit[$pos] = ($cdigit[$pos] * 2);
		$cdigit[$pos] -= 9 if($cdigit[$pos] > 9);
	}
	
	foreach $digit (@cdigit){
		$testnum += $digit;
	}
	
	if($testnum % 10){
		$ERROR{'CC_NUMBER'} = &get_error_string('You did not enter a valid credit card number. Please check number for typos.');
		$to_result++;
	}

	if($USERCONFIGS{'cc_rtime'} && $to_result>0) {
		&write_invoice_status($USERCONFIGS{'order_number'},"Card information did not pass basic card verification.");
		&mark_invoice($USERCONFIGS{'order_number'},'AutoVoid',"Card information did not pass basic card verification.");
	}
	
	return($to_result) if(!$USERCONFIGS{'cc_rtime'} || $to_result>0);
	
	
	
	print "<b>CartIt SSL Debug Mode: $ssl_debug (cartitcclib.cgi)</b><br>" if($ssl_debug);
	&get_webdat_io;
	my %CONNECTION_HASH = &get_hash('cc_connection_hash.txt');
	my $SSL_FORMDATA = '';
	my $va, $ssl_c_item;
	
	
######################################################################
# any line in cc_connection_hash.txt that start with a # (pound)
# is not parsed and is not a part of the post data.
# it can be accessed by its value. Standard types are used such as
# '#CONNECT_TO'
#
# The location that the information will be posted to.
# '#CONNECT_TO|https://www.somesite.com/'
######################################################################
	
	foreach $ssl_c_item (sort keys %CONNECTION_HASH){
		if($ssl_c_item !~/^#.*/){
			$va  = &parse_to_io_string($CONNECTION_HASH{"$ssl_c_item"});
			$va = &urlencode("$va");
			$SSL_FORMDATA .= "$ssl_c_item\=$va";
			$SSL_FORMDATA .= $ssl_debug==1 ? "\n" : "&";
			
		}
		
		
	}
	if($ssl_debug==1){
		print "<pre>URL To Connect To (#CONNECT_TO):\n";
		print "$CONNECTION_HASH{'#CONNECT_TO'}\n\n";
		
		print "REFERER (#REFERER):\n";
		print "$CONNECTION_HASH{'#REFERER'}\n\n";
		
		print "MAKE ARRAY FROM RESULT DATA (1=yes,0=no):\n";
		print "$CONNECTION_HASH{'#MAKEARRAY'}\n\n";
		
		print "DELIMITER: (for split() results):\n";
		print "$CONNECTION_HASH{'#ARRAY_DELIMITER'}\n\n";
		print "--------------------\n";
		print "DATA TO SEND:\n";
		print "--------------------\n";
		
		print "$SSL_FORMDATA</pre>";
		exit;
	}
	
	
	$ua = new LWP::UserAgent;
	$ua->from('');
	$ua->timeout(90);
	$req = new HTTP::Request('GET', "$CONNECTION_HASH{'#CONNECT_TO'}\?$SSL_FORMDATA");
	$req->content_type('application/x-www-form-urlencoded');
	$req->referer($CONNECTION_HASH{'#REFERER'}) if($CONNECTION_HASH{'#REFERER'});
	$response = $ua->request($req);
	if (!$response->is_success){
		$code = $response->code;
		$desc = HTTP::Status::status_message($code);
		&write_error("SSL Connection ERROR HTTP RESPONSE CODE='$code ($desc)' URL='$CONNECTION_HASH{'#CONNECT_TO'}'","Logged Only.");
		&write_invoice_status($USERCONFIGS{'order_number'},'ERROR in SSL connection, see cartiterror.log, order accepted but you must process manually.');
		return('');
	}
	
	
	
	$data_returned = $response->content;
	
	print 	"<tt>$data_returned</tt>" if($ssl_debug==2);
	exit if($ssl_debug==2);
	
	
	
	if($CONNECTION_HASH{'#MAKEARRAY'}){
		my $i = 0;
		@SSL_RESULT = split(/\Q$CONNECTION_HASH{'#ARRAY_DELIMITER'}/,$data_returned);
		if($ssl_debug==3){
			print "\n\nRETURN ARRAY:<br>";
			print "--------------------<br>";
			foreach $elem (@SSL_RESULT){
				print "ArrayElem[$i] at Position[" . ($i+1) ."]: $elem<br>";
				$i++;
			}
			exit;
		}
		
	}
######################################################################
# do validation on @SSL_RESULT here.
######################################################################
	open(MYFILE, "$data_directory/cc_connection_array_logic.txt");
	@CCLOGIC=(<MYFILE>);
	close(MYFILE);
	chomp(@CCLOGIC);
	foreach $cclogic (@CCLOGIC){
		($field,$result,$action,$resultstring,$notetoshopper) = split(/\|/,$cclogic);
		next if($field =~/^#/ || $field eq ''); # Accept Comments in this insane file.
			if($SSL_RESULT[$field] eq "$result"){ # Entry match
			last if($action eq 'SUCCESS'); # Get out, looks good.
			if($action eq 'REENTER'){
				&write_invoice_status($USERCONFIGS{'order_number'},&parse_to_io_string($CONNECTION_HASH{'#ARRAY_LOGGER'}));
				&mark_invoice($USERCONFIGS{'order_number'},'AutoVoid',$resultstring);
				$ERROR{'CC_TYPE'} = &get_error_string("$notetoshopper");
				return('REENTER');
				}elsif($action eq 'BANIP'){
				&write_invoice_status($USERCONFIGS{'order_number'},&parse_to_io_string($CONNECTION_HASH{'#ARRAY_LOGGER'}));
				&mark_invoice($USERCONFIGS{'order_number'},'AutoVoid',$resultstring);
				&ban_shopper_ip; #NETS IN 3 DAYS
				return($notetoshopper);
			}
			
			
		}
	}
######################################################################
# we get past all of the tests, we have a succesfull transaction.
######################################################################
	&write_invoice_status($USERCONFIGS{'order_number'},&parse_to_io_string($CONNECTION_HASH{'#ARRAY_LOGGER'}));
	return(''); # Null, is non error / success
}


sub custom_payment_routine {
	if($WEBDAT{'method'} eq "1"){
		$WEBDAT{'payment_description'} = "Credit Card";
	}elsif($WEBDAT{'method'} eq "2"){
		$WEBDAT{'payment_description'} = "Credit Card by Phone";
	}elsif($WEBDAT{'method'} eq "3"){
		$WEBDAT{'payment_description'} = "C.O.D.";
	}elsif($WEBDAT{'method'} eq "4"){
		$WEBDAT{'payment_description'} = "Purchase Order Number";
	}elsif($WEBDAT{'method'} eq "5"){
		$WEBDAT{'payment_description'} = "$USERCUSTOM{'REMOTE_SSL_DISPLAY_TEXT'}";
	}elsif($WEBDAT{'method'} eq "6"){
		$WEBDAT{'payment_description'} = "Payment by Mail";
	}


#
# Insert any custom code you wish to be called right before the final invoice is
# printed to the customers screen.  Do not stop the order since by the time it gets
# this far it is too late to stop the order and printing the invoice.  This would be
# a great spot to do payment processing calculations like the Authoirize.Net SIM method.
#


	return(1);
}


1;#Be true to PERL





















