#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################



#############################################################
# $MAIL is the path to 'sendmail' on UNIX/Linux systems
# $MAIL = '/usr/sbin/sendmail'
#
#  	--- OR ---
#
# $MAIL is the address of the SMTP server on Windows Systems
# $MAIL = 'smtp.yoursute.com'
#############################################################
$MAIL = '/usr/sbin/sendmail';




#############################################################
# $domain_name is where CartIt is installed. This domain name
# must contain two dots. Typically, this is .cartit.com NOT
# www.cartit.com.
#############################################################
$domain_name = '.yoursite.com';



###############################################################
# cart_directory is where your visitors' shopping carts will be
# stored. You must create this directory for CartIt to use. You
# should NOT keep ANY files in this directory. CartIt
# will create shopping carts and save them in this directory,
# periodically deleting all the files (expired shopping carts).
#
#
# NT Style
# $cart_directory = 'C:\folder\folder\account\carts_folder';
#
#
# UNIX STYLE
# $cart_directory = './carts';
#
###############################################################

$cart_directory = './carts';




###############################################################
# data_directory is where you will keep all of the
# configuration files. Note: Configuration files are not scripts.
# These files include message, search.txt, config, etc...
#
#
# NT Style
# $data_directory = 'C:\folder\folder\account\data_folder';
#
#
# UNIX STYLE
# $data_directory = './data';
#
###############################################################

$data_directory = './data';








##################################################################
# DO NOT EDIT THIS LINE!!!
##################################################################
$cartit_version = '8.0.07.377';


###################################################################
# $NOTRACK_REFS is an option for advanced users. It uses regular
# expressions in PERL to track referrers in the shopping cart.
# The description of items
# will be provided as links back to the main product.
# You may wish to turn off this option for pages that are generated
# dynamically and may not have the ability to be tracked.
# For example: 'cgi$|\?';
# It will not track a file that ends with 'cgi' or an item that
# contains a '?', as in, an item with a query string.
# Note: In the above example we had to escape the ? with a forward slash
# because it is a special identifier in PERL.
###################################################################
$NOTRACK_REFS = 'cgi$';




###################################################################
# $UK_TIME_FORMAT will change the date format to dd/mm/yyyy if set to 1.
# United States users should have this set to 0.
# This date format must match your local system format.
# Also note that your system must have date separators set
# to "/" NOT "-"!
# mm/dd/yyyy (U.S.) = 0
# dd/mm/yyyy (U.K.) = 1
###################################################################
$UK_TIME_FORMAT = 0;


##################################################################
# $license_number is were you enter your license number, between the
#  quotation marks. The final variable should look something like this:
#
#	$license_number='XXXXXXXXX-XXX';
#
###################################################################
$license_number = '0';




__END__


Version 8.0.04.365
	-First Wide Public Release


Version 8.0.05.370 [DATE 2/10/2003 4:49 PM]
	- Added more user/system friendly module checks
	- Fixed Credit Card Validation System
	- HTML Bug in Gift Module
	- Minor Shipping Bugs Fixed.


Version 8.0.06.375

 [cartit.cgi]
	- Fixed Invalid Custom CFO Rejection

 [cartit_checkout.cgi]
	- Fixed Real-time Shipping Requirement for proper Credit Card Processing. 
	- Fixed Real-time Shipping Requirement  for CVV request for function



Version 8.0.06.376

 [cartit_checkout.cgi]
	- Fixed Module Checking routine.

 [cartitcclib.cgi]
	- Fixed Autovoid for real time authorization when user enters invalid data and
	  it does not pass basic validation.

 [validate.html]
	- Fixed JavaScript error.

 [cartitlib.cgi]
	- Fixed problem when sending via SMTP.

 [cartitshiplib.cgi]
	- Fixed problem with printing of Ship Option when viewing as Radio button.



Version 8.0.07.377  [DATE 3/25/2003]

 [cartit.cgi]
	- Moved about CartIt sub-routine to cartitlib.cgi
	- Added weight_safety for real time shipping transactions.
	- Added version number.

 [cartit_checkout.cgi]
	- Added call to the about sub-routine.
	- Removed the requirement of XML::DOM.
	- Added call to custom payment routine in cartitcclib.cgi for custom code at checkout.
	- Added version number.
	- Added ability to do side by side checkout boxes.

 [cartitshiplib.cgi]
	- Rewrote lib to not require XML::DOM.
	- Fixed XML error when sending to UPS.
	- Fixed LB & OZ for tracking in both USPS and UPS.
	- Added USPS International Support.
	- Added More Error Checking to UPS.
	- Fixed No Shipping Error.
	- Added version number.

 [cartitcclib.cgi]
	- Added custom payment routine that is called right before printing final invoice.
	- Added a description for payment type %io_web_payment_description%
	- Added about sub-routine and made it more robust
	- Added version number.

 [commercebuddy.cgi]
	- Added call to the about sub-routine.
	- Added version number.

 [cartit_check_install.cgi]
	- Added version number.
	- Will now check to see if directories are writable by the script.

 [cartitlib.cgi]
	- Moved where the checkoutlinks anchor tag was being printed to allow it
	  to be printed for all checkout options.
	- Added version number.

 [cartitimg.util]
	- All images are set to use the /cartitimages/ directory for simplicity.
	- Commented out the body tag override feature so it will use CommerceBuddy's 
	  settings by default.

 [cartitcf.cgi]
	- Altered the samples for carts and data directory to try to not confuse
	  new users with what to enter.  Made the UNIX/Linux version default. 
