#!/usr/local/bin/perl
################################################################################################
#END USER LICENSE AGREEMENT
#
#
# This End User License Agreement ("EULA") is a legal agreement between you
# (either an individual or a single entity) (Hereinafter, "END USER", or "YOU")
# and CartIt Corporation (Hereinafter, "CARTIT CORPORATION" or "WE") for the
# CARTIT CORPORATION software product accompanying this EULA (Hereinafter "SOFTWARE"),
# which includes computer software and may include associated media, printed materials,
# and "online" or electronic documentation. By installing, copying, or otherwise using
# SOFTWARE, YOU agree to be bound by the terms of this EULA. If YOU do not agree to the
# terms of this EULA, do not install, copy, or use SOFTWARE.
#
# LICENSE GRANT: (i) CARTIT CORPORATION grants YOU a license to use one copy of the
# SOFTWARE. YOU may not modify or disable any licensing or control features of
# the SOFTWARE. (ii) The SOFTWARE is licensed to YOU to be installed and used
# on one machine only. (iii) SOFTWARE is licensed to operate on or for one
# domain name only. (iv) Only one company may use the SOFTWARE for its intended
# purpose on the domain name. This company may not sell the products or services
# of other companies in the capacity of an online mall or buyer service. If more
# than one company wishes to use the SOFTWARE they must purchase a separate license.
# (v) YOU may use the SOFTWARE only in the form originally supplied by CARTIT CORPORATION.
# YOU may not modify, decompile, disassemble, translate or reverse engineer the SOFTWARE,
# in whole or in part, and may not sublicense, rent, lease or otherwise disclose or
# disseminate the SOFTWARE to any third party except in accordance with the provisions
# of this Section. YOU may not copy the SOFTWARE, in whole or in part, other than for
# the sole purpose of backup or archive, provided that YOU reproduce all copyright,
# trademark, confidential or other proprietary notices.
#
# UPGRADES: (i) CARTIT CORPORATION is not required to notify YOU of or to provide YOU
# freely with any upgrades to the SOFTWARE. (ii) If the SOFTWARE is being provided as an
# upgrade to an older version, YOU are required to destroy all copies of the older version
# of the SOFTWARE and all its components and your license to use the older version is terminated.
#
# TECHNICAL SUPPORT: While CARTIT CORPORATION does provides very professional and extensive
# technical support and detailed documentation, CARTIT CORPORATION does not warrant or
# guarantee that WE will provide technical support for any SOFTWARE.
#
# WARRANTY: (i) CARTIT CORPORATION warrants that for a term of sixty (60) days from the date
# of delivery to END USER the SOFTWARE will perform substantially in accordance with the
# documentation provided. (ii) If the END USER asserts a defect in the SOFTWARE during the
# above defined warranty period, END USER shall be entitled as its sole remedy, and at CARTIT
# CORPORATION'S sole option and expense, to have the defective SOFTWARE replaced by
# CARTIT CORPORATION with SOFTWARE that substantially conforms to the documentation.
# (iii) If the replacement does not rectify the defect, or if the replacement is unduly delayed,
# END USER shall be entitled to a refund not to exceed the amount paid for the SOFTWARE.
# (iv) CARTIT CORPORATION shall not be liable under this warranty if its testing or examination
# discloses that the alleged defect in the SOFTWARE does not exist or was caused by END USER'S
# or any third party's misuse, neglect, improper installation or testing, lack of technical skills,
# insufficient hardware, software, or server calibration, unauthorized attempts to repair or modify,
# or any other cause beyond the range of the intended use of the SOFTWARE, or by accident, or acts
# of God. (v) CARTIT CORPORATION DOES NOT WARRANT THAT THE FUNCTIONS CONTAINED WITHIN THE SOFTWARE
# WILL MEET END USER'S REQUIREMENTS, OR WILL OPERATE IN ANY COMBINATION WHICH MAY BE SELECTED FOR
# USE BY END USER, OR THAT OPERATION OF THE SOFTWARE WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT
# ANY DEFECTS THAT MAY EXIST IN THE SOFTWARE WILL BE CORRECTED. THIS WARRANTY IS IN LIEU OF ALL
# OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING ANY WARRANTIES OF MERCHANTABILITY OR FITNESS FOR
# A PARTICULAR PURPOSE.
#
# LIMITATION OF LIABILITY: EXCEPT AS PROHIBITED BY LAW, CARTIT CORPORATION'S ENTIRE LIABILITY ARISING
# OUT OF THIS EULA SHALL BE LIMITED TO THE ORIGINAL AMOUNT PAID BY YOU FOR THE SOFTWARE. IN NO EVENT
# SHALL CARTIT CORPORATION BE LIABLE FOR COSTS OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES, LOSS
# OF USE, DATA, OR PROFITS, OR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES, ARISING OUT OF
# OR IN CONNECTION WITH THIS EULA OR THE USE OR PERFORMANCE OF SOFTWARE HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN AN ACTION FOR CONTRACT OR TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, AND
# WHETHER OR NOT CARTIT CORPORATION HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# COPYRIGHT: All title and copyrights in and to the SOFTWARE (including but not limited to any images,
# photographs, animations, video, audio, music, text, and "applets" incorporated into the SOFTWARE),
# the accompanying printed materials, and any copies of the SOFTWARE are owned by CARTIT CORPORATION
# or its suppliers. The SOFTWARE is protected by copyright laws and international treaty provisions.
# Therefore, YOU must treat the SOFTWARE like any other copyrighted material. YOU may not copy the
# printed materials, if any, accompanying the SOFTWARE.
#
# TRADE SECRETS: The SOFTWARE contains trade secrets and proprietary know-how that belongs to CARTIT
# CORPORATION and is being made available to YOU in strict confidence. ANY USE OR DISCLOSURE OF THE
# SOFTWARE, OR OF ITS ALGORITHMS, PROTOCOLS OR INTERFACES, OTHER THAN IN STRICT ACCORDANCE WITH THIS
# EULA, MAY BE ACTIONABLE AS A VIOLATION OF OUR TRADE SECRET RIGHTS.
#
# U.S. GOVERNMENT RESTRICTED RIGHTS: The SOFTWARE and documentation are provided with RESTRICTED RIGHTS.
# Use, duplication, or disclosure by the Government is subject to restrictions as set forth in subparagraph
# (c)(1)(ii) of the Rights in Technical Data and Computer Software clause at DFARS 252.227-7013 or subparagraphs
# (c)(1) and (2) of the Commercial Computer Software-Restricted Rights at 48 CFR 52.227-19, as applicable.
# Manufacturer is CartIt Corporation/2457-A S. Hiawassee Road #305/Orlando, Florida 32835
# USA.
#
# EXPORT RESTRICTIONS: YOU agree that YOU do not intend to, nor will YOU, directly or indirectly,
# export or transmit the SOFTWARE or related documentation to any country to which such export
# or transmission is restricted by any applicable U.S. regulation or statute, without the prior
# written consent, if required, of the Bureau of Export Administration of the U.S. Department of
# Commerce, or such other governmental entity that may have jurisdiction over such export or transmission.
#
# TERMINATION: (i) CARTIT CORPORATION may terminate this EULA if YOU fail to comply with the terms and
# conditions of this EULA. In such event, YOU must destroy all copies of the SOFTWARE and all of its
# component parts and documentation. (ii) In such event YOU will not be entitled to any refund in part
# of in full.
################################################################################################
$SVERSION{'cartitshiplib.cgi'} = "8.0.07.377";

if($^O eq 'MSWin32'){
	my $scriptname = $0;
	$scriptname =~ s/^(.*)[\/\\]([^\/\\]+)$/$2/;
	push(@INC,$1);
	$scriptname = $1;
}



#CONSTANTS
$USPS_URL = 'http://Production.ShippingAPIs.com/ShippingAPI.dll';
$UPS_URL= 'https://www.ups.com/ups.app/xml/Rate';
$debug_ups_connect = 0;
$timeout = 20;


%UPS_DCODES=(
		'01' => 'UPS Next Day Air&#174; 10:30 AM',
		'02' => 'UPS 2nd Day Air&#174;',
		'03' => 'UPS Ground&#174;',
		'07' => 'Worldwide Express',
		'08' => 'Worldwide Expedited',
		'11' => 'Standard',
		'12' => 'UPS 3 Day Select&#174;',
		'13' => 'UPS Next Day Air Saver&#174; 3:00 PM',
		'14' => 'UPS Next Day Air Early A.M.&#174;',
		'54' => 'Worldwide Express Plus',
		'59' => 'UPS 2nd Day Air A.M.&#174;',
		'65' => 'Express Saver'
		);

%USPS_DCODES=(
		'Express' => 'U.S. Postal Service Express Mail',
		'Priority' => 'U.S. Postal Service Priority Mail',
		'Parcel' => 'U.S. Postal Service Parcel Mail (Standard)',
		'Economy (Surface) Parcel Post' => 'U.S. Postal Service Economy (Surface) Parcel Post',
		'Airmail Parcel Post' => 'U.S. Postal Service Airmail Parcel Post',
		'Global Express Mail (EMS)' => 'U.S. Postal Service Global Express Mail (EMS)',
		'Global Express Guaranteed Document Service' => 'U.S. Postal Service Global Express Guaranteed Document Service',
		'Global Express Guaranteed Non-Document Service' => 'U.S. Postal Service Global Express Guaranteed Non-Document Service'
		);


$GLOBAL_USPS_XML =''; #init null - Do NOT EDIT!
$GLOBAL_UPS_XML =''; #init null - Do NOT EDIT!
$FOP = ' checked'; # Do NOT EDIT!


# ------------------------------------------------------------------------
sub getshipping{
	return('') if(!$USERCONFIGS{'use_shipping'});
	&shippingheader;
	&do_shipping_code;
	&shippingfooter;
}












# ------------------------------------------------------------------------
sub do_shipping_code{
	
	if($USERCONFIGS{'shipping_method'} eq 'livemethods'){
		
		if($USERCONFIGS{'useusps'}){
			&start_usps;
			if ($WEBDAT{'country2'} eq 'US') {
				foreach $uspsmethods (@{$USERCUSTOM{"Process_Services"}}){
					if($USERCONFIGS{'combine_items'}){
						&add_usps_package("$uspsmethods",'',"$WEBDAT{'zip2'}","$CUSTOM_SHIPPING_TOTAL_WEIGHT",'None','Regular','False');
						}else{
						foreach $x (keys %CUSTOM_SHIPPING_CONNECT_HASHD){
							for($i=1;$i<=$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[1];$i++){
								$SHIPDUPLEX{"$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]-$uspsmethods"}++;
								if($SHIPDUPLEX{"$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]-$uspsmethods"}<=1){
									&add_usps_package("$uspsmethods",'',"$WEBDAT{'zip2'}","$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]","None",'Regular','False');
								}
							}
						}
					}
				}
			}
			else {
				foreach $uspsmethods (@{$USERCUSTOM{"Process_Intl_Services"}}){
					if(!$USERCONFIGS{'combine_items'}){
						foreach $x (keys %CUSTOM_SHIPPING_CONNECT_HASHD){
							for($i=1;$i<=$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[1];$i++){
								$SHIPDUPLEX{"$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]-$uspsmethods"}++;
								push(@SHIPTEMP,"$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]-$uspsmethods");
							}
						}
					}
				}
				if($USERCONFIGS{'combine_items'}){
					&add_usps_package("",'',"$WEBDAT{'zip2'}","$CUSTOM_SHIPPING_TOTAL_WEIGHT","Package",'Regular','False');
					}else{
					foreach $x (keys %CUSTOM_SHIPPING_WEIGHT_HASH){
						&add_usps_package("$uspsmethods",'',"$WEBDAT{'zip2'}",$x,"None",'Regular','False');
					}
				}
			}
			&end_usps;
			%usps_items = &get_usps;
		}
		
		
		
		
# Non Production server will not accept non 3lb items, do not forget this.

		if($USERCONFIGS{'useups'}){
#undef %SHIPDUPLEX;
			&start_ups("", $WEBDAT{'zip2'});
			if($USERCONFIGS{'combine_items'}){
				&add_ups_package("$CUSTOM_SHIPPING_TOTAL_WEIGHT");
				}else{
				foreach $x (keys %CUSTOM_SHIPPING_CONNECT_HASHD){
					for($i=1;$i<=$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[1];$i++){
						$SHIPDUPLEX{$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]}++;
						if($SHIPDUPLEX{$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]}<=1){
							&add_ups_package("$CUSTOM_SHIPPING_CONNECT_HASHD{$x}[0]");
						}
					}
					
				}
			}
			
			&end_ups;
			%ups_items = &get_ups;
		}
		
		
# Done Connecting
		
		
		&print_shipstart_select;
		
		if(%usps_items){
			$USERCUSTOM{'SHIPPED_TEXT_DESCRIPTION'} = '';
			print "<tr><td colspan=\"3\"><b>United States Postal Service</b></td></tr>";
			foreach $mitems (keys %usps_items){
				$GOT_LIVE =1;
				$usps_items{$mitems} += $USERCONFIGS{'add_handling'};
				&print_ship_option($usps_items{$mitems}, "$mitems");
			}
		}
		
		if(%ups_items){
			
			$USERCUSTOM{'SHIPPED_TEXT_DESCRIPTION'} = '';
			print "<tr><td colspan=\"3\"><b>United Parcel Service</b></td></tr>";
			foreach $mitems (sort keys %ups_items){
				$GOT_LIVE =1;
				$ups_items{$mitems} += $USERCONFIGS{'add_handling'};
				&print_ship_option("$ups_items{$mitems}","$mitems");
			}
			
		}
		
		&print_ship_option("0.00","Will quote shipping")if(!$GOT_LIVE);
		
		
		&print_shipend_select;
		print "An error occurred when attempting to connect for shipping quotes. Your account representative will quote shipping after you place your order." if(!$GOT_LIVE);
		
		
		return;
	}
	
	
	
	my @A_SHIPIT;
	my %SHIPIT;
	
	
	if(($USERCONFIGS{'shipping_method'} eq 'shipit') ||($USERCONFIGS{'shipping_method'} eq 'basicshipit')||($USERCONFIGS{'shipping_method'} eq 'my_custom_NULL')){
		$shippingfee = 0;
#------------------------------------------------------------------------------------------------------------------------
		if($USERCONFIGS{'shipping_method'} eq 'shipit'){
			open(FILE, "$data_directory/shipit.dat") ||&system_busy;
			@A_SHIPIT=(<FILE>);
			close(FILE);
			chomp(@A_SHIPIT);
			foreach $codeline (@A_SHIPIT){
				($c, $f)=split(/\|/,$codeline);
				$SHIPIT{$c} = $f;
			}
		}
		
		
#------------------------------------------------------------------------------------------------------------------------
		
		
		foreach $weight (keys %CUSTOM_SHIPPING_WEIGHT_HASH){
			
			
			if($USERCONFIGS{'shipping_method'} eq 'shipit' || $USERCONFIGS{'shipping_method'} eq 'my_custom_NULL'){
				if($SHIPIT{"$weight"} >0){
					$shippingfee += sprintf("%.2f",($SHIPIT{"$weight"}*$CUSTOM_SHIPPING_WEIGHT_HASH{$weight}));
					}else{
					$shippingfee += sprintf("%.2f",($SHIPIT{$USERCONFIGS{'weight_safety'}}*$CUSTOM_SHIPPING_WEIGHT_HASH{$weight}));
				}
				
				}else{ #end advanced
				if($weight){
					$shippingfee += sprintf("%.2f",($USERCONFIGS{'basicshipit_multiplier'} * $weight) * $CUSTOM_SHIPPING_WEIGHT_HASH{$weight});
					}else{
					$shippingfee += sprintf("%.2f",($USERCONFIGS{'basicshipit_multiplier'} * $USERCONFIGS{'weight_safety'}) *$CUSTOM_SHIPPING_WEIGHT_HASH{$weight});
				}
			}
		}
		
		
		if($USERCONFIGS{'shipping_method'} eq 'shipit' || $USERCONFIGS{'shipping_method'} eq 'my_custom_NULL' ){
			$shippingfee+= $USERCONFIGS{'advancedshipit_base'};
			}elsif($USERCONFIGS{'shipping_method'} eq "basicshipit"){
			$shippingfee+= $USERCONFIGS{'basicshipit_base'};
		}
		
		
		}elsif($USERCONFIGS{'shipping_method'} eq 'basic' || $USERCONFIGS{'shipping_method'} eq 'my_custom_NULL'){
		$shippingfee = 0; #safe
		$shippingfee=  $USERCONFIGS{'basic_base'} + ($USERCONFIGS{'basic_percentage'} * $CUSTOM_SHIPPING_CART_TOTAL);
		
		}elsif($USERCONFIGS{'shipping_method'} eq 'peritem' || $USERCONFIGS{'shipping_method'} eq 'my_custom_NULL'){
		$shippingfee = 0; #safe
		$shippingfee = ((($CUSTOM_SHIPPING_ITEMS_IN_CART -1) * $USERCONFIGS{'peritem_additional'}) + $USERCONFIGS{'peritem_first'});
		
		
		
		
		
		
#CUSTOM_CODE_ENTRY_POINT
#----------------------------------------------------------------------------------------
#You Have Access To
#$CUSTOM_SHIPPING_WEIGHT_HASH{"$weight"} += $quantity;
#$CUSTOM_SHIPPING_TOTAL_WEIGHT += ($quantity * $weight);
#$CUSTOM_SHIPPING_ITEMS_IN_CART +=$quantity;
#$CUSTOM_SHIPPING_PRICES_IN_CART{"$amount"}+=$quantity;
#$CUSTOM_SHIPPING_CART_TOTAL += sprintf("%.2f",$amount); #after cartitqd
#%WEBDAT including (state, state2, country, country2, zip, zip2)
		
#Sample 1
		}elsif($USERCONFIGS{'shipping_method'} eq 'my_custom_cartitxmp1'){
		
		&print_shipstart_select;
		
		$thisfee = ((($CUSTOM_SHIPPING_ITEMS_IN_CART -1) * 5.00) + 8.00);
		&print_ship_option($thisfee,'UPS Ground');
		
		$thisfee = ((($CUSTOM_SHIPPING_ITEMS_IN_CART -1) * 8.00) + 19.00);
		&print_ship_option($thisfee,'Second Day Air');
		
		$thisfee = ((($CUSTOM_SHIPPING_ITEMS_IN_CART -1) * 8.00) + 25.00);
		&print_ship_option($thisfee,'Overnite Standard');
		
		$thisfee = ((($CUSTOM_SHIPPING_ITEMS_IN_CART -1) * 8.00) + 29.00);
		&print_ship_option($thisfee,'Overnite Priority');
		
		&print_shipend_select;
		return();
		
		
#Sample 2
		}elsif($USERCONFIGS{'shipping_method'} eq 'my_custom_cartitxmp2'){
		if($CUSTOM_SHIPPING_CART_TOTAL < 100.00){
			$shippingfee = 4.95;
			}else{
			$shippingfee = 00.00;
		}
		&print_shiphidden($shippingfee);
		return();
		
		
# Sample 3
		}elsif($USERCONFIGS{'shipping_method'} eq 'my_custom_cartitxmp3'){
		$my_custom_sct = $CUSTOM_SHIPPING_CART_TOTAL;
		if($my_custom_sct < 29.99){
			$shippingfee = 5.00;
			}elsif($my_custom_sct >= 30.00 && $my_custom_sct < 60.00){
			$shippingfee = 7.00;
			}elsif($my_custom_sct >= 60.00 && $my_custom_sct < 80.00){
			$shippingfee = 9.00;
			}elsif($my_custom_sct >= 80.00 && $my_custom_sct < 100.00){
			$shippingfee= 11.00;
			}elsif($my_custom_sct >= 100.00 && $my_custom_sct < 150.00){
			$shippingfee = 13.00;
			}elsif($my_custom_sct >= 150.00 && $my_custom_sct < 250.00){
			$shippingfee = 15.00;
			}elsif($my_custom_sct >= 250.00 && $my_custom_sct < 350.00){
			$shippingfee = 19.00;
			}elsif($my_custom_sct >= 350.00 && $my_custom_sct < 450.00){
			$shippingfee = 21.00;
			}elsif($my_custom_sct >= 450.00 && $my_custom_sct < 500.00){
			$shippingfee = 25.00;
			}else{
#$my_custom_sct >=500.00
			$shippingfee = 35.00;
			
		}
		&print_shiphidden($shippingfee);
		return();
		
	}
	
	
	
	
# STOP EDITING - NEVER EDIT!
# If you do not print and return() then cartitshiplib.cgi will do it here,
# and will check for shipping extensions.
	if($USERCONFIGS{'use_shipit_extensions'} ==1){
		open(FILE, "$data_directory/shipext.txt") || die $!;
		@SHIPEXT=<FILE>;
		close(FILE);
		&print_shipstart_select;
		&print_ship_option($shippingfee,$USERCONFIGS{'default_shipping_message'});
		
		
		foreach $ship (@SHIPEXT){
			chomp($ship);
			my($sdescription,$sfee,$sperc) = split(/\|/,$ship);
			$thisfee = ($sfee + (($sperc * $shippingfee) + $shippingfee));
			&print_ship_option($thisfee,$sdescription);
		}
		&print_shipend_select;
		return(); # Exit this sub
		}else{
		&print_shiphidden($shippingfee);
		
	}
	
	
}




sub shippingheader{
	
	
	$USERCUSTOM{'SHIPPED_HEADER'}='Shipping';
	$USERCUSTOM{'SHIPPED_TEXT_DESCRIPTION'} = 'Your items will be shipped by:<p>';
	
	
	print "		<TR class=smallheading>\n";
	print "		<TD colspan=\"2\">$USERCUSTOM{'SHIPPED_HEADER'}</TD>\n";
	print "		</TR>\n";
	print "$ERROR{'shippingerr'}\n";
	print '<input type="HIDDEN" name="web_shipping_fee_enabled" value="1">';
	
	print "		<TR class=\"checkouttablebody\">\n";
	print "		<TD colspan=\"2\">";
	
	
	print "		<TABLE WIDTH=\"100%\" CELLPADDING=\"2\"\n";
	print "		CELLSPACING=\"2\" BORDER=\"0\">\n";
	print "		<TR class=\"checkouttablebody\">\n";
	print "		<TD>$USERCUSTOM{'SHIPPED_TEXT_DESCRIPTION'}\n";
	
	
}

sub shippingfooter{
	print "		</TD>\n";
	print "		</TR>\n";
	print "		</TABLE>\n";
	print "		</TD>\n";
	print "		</TR>\n";
}



sub print_shiphidden{
	my($fee,$message) = @_;
	$message = $USERCONFIGS{'default_shipping_message'} if($message eq '');
	print sprintf("<INPUT TYPE=\"hidden\" NAME=\"web_shipping_fee\" VALUE=\"%.2f^$message\">$message for $USERCONFIGS{'money_sign'}%.2f\n",$fee,$fee);
	
}

sub print_shipstart_select{
	if($USERCUSTOM{'SHIP_AS_RADIO'}){
		print '<table width="100%" cellpadding="0" cellspacing="2" border="0">';
		}else{
		print "<SELECT NAME=\"web_shipping_fee\">\n";
		
	}
	
	
}


sub print_shipend_select{
	if($USERCUSTOM{'SHIP_AS_RADIO'}){
		print "</table>\n";
		}else{
		print "</SELECT>\n";
	}
	
}

sub print_ship_option{
	my($fee,$message) = @_;
	return() if($message eq '');
	if($USERCUSTOM{'SHIP_AS_RADIO'}){
		print sprintf("<tr><td width=\"5\%\"><INPUT TYPE=\"RADIO\" NAME=\"web_shipping_fee\" VALUE=\"%.2f^$message\"$FOP></td><td>$message</td><td align=\"right\"><span class=\"price\">$USERCONFIGS{'money_sign'}%.2f</span></td></tr>\n",$fee,$fee);
		}else{
		print sprintf("<OPTION VALUE=\"%.2f^$message\">$message -- $USERCONFIGS{'money_sign'}%.2f\n",$fee,$fee);
	}
	$FOP='';
	
}









# -------------------------------------------------------------------------------------------
sub start_usps{

	if ($WEBDAT{'country2'} ne 'US') {
		$GLOBAL_USPS_XML = "<IntlRateRequest USERID=\"$USERCONFIGS{'usps_username'}\" PASSWORD=\"$USERCONFIGS{'usps_password'}\">";
	}
	else {
		$GLOBAL_USPS_XML = "<RateRequest USERID=\"$USERCONFIGS{'usps_username'}\" PASSWORD=\"$USERCONFIGS{'usps_password'}\">";
	}
	$USPS_PACKAGE_ID = 0;

}


# -------------------------------------------------------------------------------------------
sub end_usps{

	if ($WEBDAT{'country2'} ne 'US') {
		$GLOBAL_USPS_XML .='</IntlRateRequest>';
	}
	else {
		$GLOBAL_USPS_XML .='</RateRequest>';
	}
}


# -------------------------------------------------------------------------------------------
sub add_usps_package{
# This is not a pretty as package usage but it is faster.
	my($method, $originzip, $destzip, $pounds, $container, $size, $machinable) = @_;
#write_error("'$pounds'");
	($pounds,$ounces) = &oztoreal($pounds);
#write_error("\'$pounds,\'");
	my($or);
	$or = 1 if ($WEBDAT{'country2'} =~ /(AS|FM|MP|MH|VI|GU|KO|PW|PA|PR|TU|WK)/i);
	if ($WEBDAT{'country2'} ne 'US' && !$or) {
		foreach $country (keys(%COUNTRIES)) {
			if ($WEBDAT{'country2'} eq $COUNTRIES{$country}) {
				$usps_country = $country;
				$usps_country = $COUNTRIES_CONVERT{$WEBDAT{'country2'}} if ($COUNTRIES_CONVERT{$WEBDAT{'country2'}} ne "");
			}
			next if $usps_country;
		}
		$GLOBAL_USPS_XML .= "<Package ID=\"$USPS_PACKAGE_ID\">";
		$GLOBAL_USPS_XML .= "<Pounds>$pounds</Pounds>";
		$GLOBAL_USPS_XML .= "<Ounces>$ounces</Ounces>";
		$GLOBAL_USPS_XML .= "<MailType>Package</MailType>";
		$GLOBAL_USPS_XML .= "<Country>$usps_country</Country>";
		$GLOBAL_USPS_XML .= "</Package>";
		$USPS_PACKAGE_ID++;
	}
	else {
		$originzip = $USERCONFIGS{'shipping_origin_zip'} if($originzip eq '');
		$GLOBAL_USPS_XML .= "<Package ID=\"$USPS_PACKAGE_ID\">";
		$GLOBAL_USPS_XML .= "<Service>$method</Service>";
		$GLOBAL_USPS_XML .= "<ZipOrigination>$originzip</ZipOrigination>";
		$GLOBAL_USPS_XML .= "<ZipDestination>$destzip</ZipDestination>";
		$GLOBAL_USPS_XML .= "<Pounds>$pounds</Pounds>";
		$GLOBAL_USPS_XML .= "<Ounces>$ounces</Ounces>";
		$GLOBAL_USPS_XML .= "<Container>$container</Container>";
		$GLOBAL_USPS_XML .= "<Size>$size</Size>";
		$GLOBAL_USPS_XML .= "<Machinable>$machinable</Machinable>";
		$GLOBAL_USPS_XML .= "</Package>";
		$USPS_PACKAGE_ID++;
	}

}






sub get_usps{
	$/ = "\n";
	my %pack_options;
	my $this_ptype;
	$ua = new LWP::UserAgent;
	$ua->agent("CartIt Shipping Library / V$SCRIPTVERSION{'cartitshiplib.cgi'}");
	$ua->timeout($timeout);
	$ua->from("$USERCONFIGS{'webmaster'}");
	$req = new HTTP::Request 'POST', "$USPS_URL";
	$req->content_type('application/x-www-form-urlencoded');

	print $req->content('API=Rate&XML=' . $GLOBAL_USPS_XML) if ($WEBDAT{'country2'} eq 'US');
	print $req->content('API=IntlRate&XML=' . $GLOBAL_USPS_XML) if ($WEBDAT{'country2'} ne 'US');
	
	$response = $ua->request($req);
	if (!$response->is_success){
		$code = $response->code;
		$desc = HTTP::Status::status_message($code);
		&write_error("Connection Error (USPS) $code / $desc /$USPS_URL");
		return;
	}
	
	$resp = $response->content;


	if ($resp =~ /<Error>(.+?)<\/Error>/s) {
		&write_error("Response from USPS was an ERROR");
		return;
	}
	my %DCODES = %USPS_DCODES;

	for ($i=0;($usps_xml_temp) = ($resp =~ /<Package ID=\"$i\">(.+?)<\/Package>/si);$i++){
		if ($usps_xml_temp =~ /<Service>(.+?)<\/Service>/si) {
			$SHIPRECS[$i][0] = $1;
			if ($usps_xml_temp =~ /<Pounds>(.+?)<\/Pounds>/si) {
				$lb = $1;
				($oz) = ($usps_xml_temp =~ /<Ounces>(.+?)<\/Ounces>/si);
				$SHIPRECS[$i][1] = ($lb . "." . $oz);
			}
			if ($usps_xml_temp =~ /<Postage>(.+?)<\/Postage>/si) {
				$SHIPRECS[$i][2] = $1;
			}
			$SHIPRECS[$i][1]= &convertozlb($SHIPRECS[$i][1],'tooz');
			$SHIPRECS[$i][2]=($SHIPDUPLEX{"$SHIPRECS[$i][1]-$SHIPRECS[$i][0]"}*$SHIPRECS[$i][2])if(!$USERCONFIGS{'combine_items'});
			$pack_options{$DCODES{$SHIPRECS[$i][0]}}+= $SHIPRECS[$i][2];
		}
		elsif ($usps_xml_temp =~ /<Service ID(.+?)\/Service>/si) {
			$p = 0;
			while ($usps_xml_temp =~ /Service ID=\"$p\"/) {
				($usps_xml_service_temp) = ($usps_xml_temp =~ /<Service ID=\"$p\">(.+?)<\/Service>/si);
				($usps_ship_method) = ($usps_xml_service_temp =~ /<SvcDescription>(.+?)<\/SvcDescription>/si);

				$SHIPRECS[$i][0] = $1;
				if ($usps_xml_service_temp=~ /<Pounds>(.+?)<\/Pounds>/si) {
					$lb = $1;
					($oz) = ($usps_xml_temp =~ /<Ounces>(.+?)<\/Ounces>/si);
					$SHIPRECS[$i][1] = ($lb . "." . $oz);
				}
				if ($usps_xml_service_temp =~ /<Postage>(.+?)<\/Postage>/si) {
					$SHIPRECS[$i][2] = $1;
				}
				$SHIPRECS[$i][1]= &convertozlb($SHIPRECS[$i][1],'tooz');
				$SHIPRECS[$i][2]=($SHIPDUPLEX{"$SHIPRECS[$i][1]-$usps_ship_method"}*$SHIPRECS[$i][2])if(!$USERCONFIGS{'combine_items'});
				$pack_options{$DCODES{$usps_ship_method}}+= $SHIPRECS[$i][2];
				$p++;
			}
		}

	}
	
	return(%pack_options);
	
}




# -------------------------------------------------------------------------------------------
sub start_ups{
	my($originzip, $destzip) = @_;
	$originzip = $USERCONFIGS{'shipping_origin_zip'} if($originzip eq '');
	$GLOBAL_UPS_XML = '<?xml version="1.0"?>';
	$GLOBAL_UPS_XML .= '<AccessRequest xml:lang="en-US">';
	$GLOBAL_UPS_XML .= "<AccessLicenseNumber>$USERCONFIGS{'ups_key'}</AccessLicenseNumber>" if($USERCONFIGS{'ups_key'} ne '');
	$GLOBAL_UPS_XML .= "<UserId>$USERCONFIGS{'ups_username'}</UserId>";
	$GLOBAL_UPS_XML .= "<Password>$USERCONFIGS{'ups_password'}</Password>";
	$GLOBAL_UPS_XML .= '</AccessRequest>';
	$GLOBAL_UPS_XML .= '<?xml version="1.0"?>';
	$GLOBAL_UPS_XML .= '<RatingServiceSelectionRequest xml:lang="en-US">';
	$GLOBAL_UPS_XML .= '<Request>';
	$GLOBAL_UPS_XML .= '<TransactionReference>';
	$GLOBAL_UPS_XML .= '<CustomerContext>Rating and Service</CustomerContext>';
	$GLOBAL_UPS_XML .= '<XpciVersion>1.0001</XpciVersion>';
	$GLOBAL_UPS_XML .= '</TransactionReference>';
	$GLOBAL_UPS_XML .= '<RequestAction>Rate</RequestAction>';
	$GLOBAL_UPS_XML .= '<RequestOption>shop</RequestOption>';
	$GLOBAL_UPS_XML .= '</Request>';
	
	$GLOBAL_UPS_XML .= '<PickupType>';
	$GLOBAL_UPS_XML .= '<Code>01</Code>';
	$GLOBAL_UPS_XML .= '</PickupType>';

	$GLOBAL_UPS_XML .= '<Shipment>';

	$GLOBAL_UPS_XML .= '<Shipper>';
	$GLOBAL_UPS_XML .= '<Address>';
	$GLOBAL_UPS_XML .= "<PostalCode>$originzip</PostalCode>";
	$GLOBAL_UPS_XML .= '</Address>';
	$GLOBAL_UPS_XML .= '</Shipper>';
	$GLOBAL_UPS_XML .= '<ShipTo>';
	$GLOBAL_UPS_XML .= '<Address>';
	$GLOBAL_UPS_XML .= "<PostalCode>$destzip</PostalCode>";
	$GLOBAL_UPS_XML .= "<CountryCode>$WEBDAT{'country2'}</CountryCode>";
	$GLOBAL_UPS_XML .= '</Address>';
	$GLOBAL_UPS_XML .= '</ShipTo>';
	$GLOBAL_UPS_XML .= '<Service>';
	$GLOBAL_UPS_XML .= '<Code>11</Code>';
	$GLOBAL_UPS_XML .= '</Service>';

	$UPS_PACKAGE_ID = 0;

}


# -------------------------------------------------------------------------------------------
sub end_ups{
	$GLOBAL_UPS_XML .= '</Shipment>';
	$GLOBAL_UPS_XML .= '</RatingServiceSelectionRequest>';
}










# -------------------------------------------------------------------------------------------
sub add_ups_package{
# This is not a pretty as package usage but it is faster.
	my($pounds) = @_;

	($pounds,$ounces) = &oztoreal($pounds);
	
	$GLOBAL_UPS_XML .= '<Package>';
	$GLOBAL_UPS_XML .= '<PackagingType>';
	$GLOBAL_UPS_XML .= '<Code>02</Code>';
	$GLOBAL_UPS_XML .= '<Description>Package</Description>';
	$GLOBAL_UPS_XML .= '</PackagingType>';
	$GLOBAL_UPS_XML .= '<Description>Rate Shopping</Description>';
	$GLOBAL_UPS_XML .= '<PackageWeight>';
	$GLOBAL_UPS_XML .= "<Weight>$pounds.$ounces</Weight>";
	$GLOBAL_UPS_XML .= '</PackageWeight>';
	$GLOBAL_UPS_XML .= '</Package>';
	
	$UPS_PACKAGE_ID++;
}





sub get_ups{
	my %pack_options;
	my $this_ptype;
	$ua = new LWP::UserAgent;
	$ua->agent("CartIt Shipping Library / V$SCRIPTVERSION{'cartitshiplib.cgi'}");
	$ua->timeout($timeout);
	$ua->from("$USERCONFIGS{'webmaster'}");
	$req = new HTTP::Request 'POST', "$UPS_URL";
	$req->content_type('application/x-www-form-urlencoded');
	
	print $req->content($GLOBAL_UPS_XML);
	
	$response = $ua->request($req);
	if (!$response->is_success){
		$code = $response->code;
		$desc = HTTP::Status::status_message($code);
		&write_error("Connection Error (UPS) $code / $desc /$UPS_URL");
		return;
	}
	$resp = $response->content;
	if($debug_ups_connect){
		open(MYFILE, ">$data_directory/last_ups_xml_topost.xml");
		print MYFILE "$GLOBAL_UPS_XML";
		print MYFILE "\n\n\n\n\nResponse\n\n\n\n";
		print MYFILE "$resp";
		close(MYFILE);
	}
	if ($resp =~ /Error/s) {
		($code,$trash,$message)  = ($resp =~ /<ErrorCode>(.+?)<\/(.+?)<ErrorDescription>(.+?)<\//si);
		&write_error("Error $code: $message");
		return;
	}
	my %DCODES= %UPS_DCODES;
	$i = 0;
	while ($resp =~ /<RatedShipment>(.+?)<\/RatedShipment>/si) {
		$ups_xml_temp = $1 if ($1);
		$resp =~ s/\<RatedShipment>$1<\/RatedShipment>//ge;
		($trash,$SHIPRECS[$i][0])  = ($ups_xml_temp =~ /<Service(.+?)Code>(.+?)<\/Code>/si);
		$failsafe2 = 0;
		while ($ups_xml_temp =~ /<RatedPackage>(.+?)<\/RatedPackage>/si) {
			$ups_xml_temp2 = $1 if ($1);
			$ups_xml_temp =~ s/\<RatedPackage>$1<\/RatedPackage>//ge;
			($SHIPRECS[$i][1])  = ($ups_xml_temp2 =~ /<Weight>(.+?)<\/Weight>/si);
			($trash,$SHIPRECS[$i][2])  = ($ups_xml_temp2 =~ /<TotalCharges(.+?)MonetaryValue>(.+?)<\/MonetaryValue>/si);
			$SHIPRECS[$i][1]= &convertozlb($SHIPRECS[$i][1],'tooz'); # go back to defaul OZ, format for $SHIPDUPLEX prevention hash
			$SHIPRECS[$i][2]=($SHIPDUPLEX{$SHIPRECS[$i][1]}*$SHIPRECS[$i][2])if(!$USERCONFIGS{'combine_items'});
			$pack_options{$DCODES{$SHIPRECS[$i][0]}}+= $SHIPRECS[$i][2];
			$failsafe2++;
			exit if $failsafe2 > 1000;
		}
		$failsafe++;
		exit if $failsafe > 1000;
		$i++;
	}
	return(%pack_options);
}

%COUNTRIES_CONVERT = (
"GB", "Great Britain and Northern Ireland",
"AG", "Antigua and Barbuda",
"BC", "Antigua and Barbuda",
"BL", "Netherlands Antilles",
"BN", "Brunei Darussalam",
"CE", "Spain",
"CV", "Cape Verde",
"NN", "Great Britain and Northern Ireland",
"CN", "China",
"CX", "Australia",
"CO", "Australia",
"CG", "Congo (Brazzaville),Republic of the",
"CK", "New Zealand",
"CB", "Netherlands Antilles",
"EN", "Great Britain and Northern Ireland",
"HO", "Holland",
"CI", "Cote d lvoire (Ivory Coast)",
"KR", "Korea, Republic of (South Korea)",
"MK", "Macedonia, Republic of",
"ME", "Portugal",
"MC", "France",
"MM", "Burma",
"NV", "St. Christopher and Nevis",
"NU", "New Zealand",
"NF", "Australia",
"NB", "Great Britain and Northern Ireland",
"SS", "Netherlands Antilles",
"SF", "Great Britain and Northern Ireland",
"NT", "Guadeloupe",
"SW", "St. Christopher and Nevis",
"EU",  "Netherlands Antilles",
"KN", "St. Christopher and Nevis",
"MB", "Netherlands Antilles",
"TB", "Guadeloupe",
"SY", "Syrian Arab Republic",
"TA", "French Polynesia",
"TT", "Trinidad and Tobago",
"WL", "Great Britain and Northern Ireland",
);


1;#return true to compiler;
